<template lang="pug">
form.form( @submit.prevent='submit' )
	b-fields
		b-field( label="Role" :on-border='true' )
			b-select( v-model='data.role' :data='roles' field="name" expanded )
		b-field( label="Username" :on-border='true' )
			b-input( v-model='data.username' )
		b-field( label="Password" :on-border='true' )
			b-input( v-model='data.password' input-type="password" )
		b-field
			b-button( node="button" type="primary" :loading='loading' fullwidth ) {{$t("buttons.create")}}
</template>

<script setup>
import BFields from "@/components/form/Fields.vue"
import BField from "@/components/form/Field.vue"
import BInput from "@/components/form/Input.vue"
import BSelect from "@/components/form/Select.vue"

import { useToast } from "vue-toastification"
import { computed, ref } from "vue"
import { useI18n } from "vue-i18n"

const props = defineProps({ loading: Boolean })
const emit = defineEmits([ "submit" ])

const {t} = useI18n()
const toast = useToast()

const data = ref({
	username: null,
	password: null,
	role: null
})

const roles = computed(() => [
	{ i: 0, name: t("default.roles.0") },
	{ i: 1, name: t("default.roles.1") }
])

const submit = () => {
	if (props.loading) return
	if (!data.value.username || !data.value.password || !data.value.role) return toast.warning(t("default.not_all_filled"))

	let body = JSON.parse( JSON.stringify(data.value) )

	body.role = body.role.i

	emit("submit", body)
}
</script>